## nvidia-open-gpu-kernel-modules 535.247.01

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (535.247.01-1~deb12u1) bookworm; urgency=medium

  * Rebuild for bookworm.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 08 May 2025 22:10:43 +0200

nvidia-open-gpu-kernel-modules (535.247.01-1) unstable; urgency=medium

  * New upstream LTS and Tesla branch release 535.247.01 (2025-04-17).
    * Fixed CVE-2025-23244.  (Closes: #1104076)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5630
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 07 May 2025 21:25:12 +0200

nvidia-open-gpu-kernel-modules (535.230.02-1) unstable; urgency=medium

  * New upstream LTS and Tesla branch release 535.230.02 (2025-01-16).
    * Fixed CVE-2024-0150, CVE-2024-0147, CVE-2024-53869, CVE-2024-0131,
      CVE-2024-0149.  (Closes: #1093916)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5614
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 03 May 2025 20:16:34 +0200

nvidia-open-gpu-kernel-modules (535.216.03-4) unstable; urgency=medium

  * Do not add -mfunction-return=thunk-extern flag, breaks backwards
    compatibility with kernels built without this flag.
  * Apply both patch sets manually.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 14 Apr 2025 21:06:39 +0200

nvidia-open-gpu-kernel-modules (535.216.03-3) unstable; urgency=medium

  * Backport NV_MODULE_IMPORT_NS_TAKES_STRING_LITERAL and
    NV_CRYPTO_AKCIPHER_VERIFY_PRESENT changes from 550.144.03 and
    NV_FOLIO_TEST_SWAPCACHE_PRESENT changes from 565.57.01 to fix open kernel
    module build for Linux 6.13.
  * Let pahole ignore language c++11 for BTF generation.  (Closes: #1098812)
  * Fix warnings during open module build.
  * Build with more kernel hardening flags.
  * Sync with src:nvidia-graphics-drivers.
  * Bump Standards-Version to 4.7.2. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 02 Apr 2025 22:07:13 +0200

nvidia-open-gpu-kernel-modules (535.216.03-2) unstable; urgency=medium

  * Sync with src:nvidia-graphics-drivers.  (Closes: #1090361)

 -- Andreas Beckmann <anbe@debian.org>  Thu, 20 Feb 2025 02:32:44 +0100

=== debian/control ===
Source: nvidia-open-gpu-kernel-modules
Section: contrib/kernel
Priority: optional
Maintainer: Debian NVIDIA Maintainers <pkg-nvidia-devel@lists.alioth.debian.org>
Uploaders:
 Andreas Beckmann <anbe@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 quilt,
Build-Depends-Arch:
 dh-sequence-dkms,
 linux-headers-amd64 [amd64] <!nocheck>,
 linux-headers-arm64 [arm64] <!nocheck>,
Rules-Requires-Root: no
Standards-Version: 4.7.2
Homepage: https://github.com/NVIDIA/open-gpu-kernel-modules
Vcs-Browser: https://salsa.debian.org/nvidia-team/nvidia-open-gpu-kernel-modules
Vcs-Git: https://salsa.debian.org/nvidia-team/nvidia-open-gpu-kernel-modules.git
Testsuite: autopkgtest-pkg-dkms

#Package: ${nvidia-kernel}-support
Package: nvidia-open-kernel-support
Architecture: amd64 arm64
Multi-Arch: foreign
Depends:
 ${nvidia}-alternative-${nvidia:Version} | nvidia-alternative-${nvidia:Version},
 nvidia-kernel-common (>= 20151021),
 nvidia-modprobe (>= ${nvidia:Version:major}),
 ${misc:Depends}
Provides:
 nvidia-kernel-support-any,
 ${nvidia-kernel}-support--v1,
 nvidia-open-kernel-support-${nvidia:Version},
Conflicts:
 nvidia-open-kernel-support-${nvidia:Version},
Description: NVIDIA open kernel module support files${nvidia:VariantDesc}
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 ${nvidia:Models}
 .
 This package provides supporting configuration for the kernel module.

#Package: ${nvidia-kernel}-dkms
Package: nvidia-open-kernel-dkms
Architecture: amd64 arm64
Multi-Arch: foreign
Pre-Depends:
 nvidia-installer-cleanup,
Depends:
 firmware-${nvidia}-gsp (= ${nvidia:Version}) | firmware-nvidia-gsp-${nvidia:Version},
 ${nvidia-kernel}-support--v1,
 ${misc:Depends}
Provides:
 ${nvidia-kernel}-${nvidia:Version},
 nvidia-open-kernel-${nvidia:Version},
 nvidia-open-kernel-dkms-any (= ${nvidia:Version}),
Description: NVIDIA open kernel module DKMS source${nvidia:VariantDesc}
 This package builds the NVIDIA binary kernel modules needed by
 ${nvidia}-driver, using DKMS.
 Provided that you have the kernel header packages installed, the kernel
 module will be built for your running kernel and automatically rebuilt for
 any new kernel headers that are installed.
 .
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 ${nvidia:Models}
 .
 Building the kernel modules has been tested up to Linux ${nvidia:kmod:tested:Linux}.
 .
 Note: The new 'non-free-firmware' archive area has to be enabled in apt's
 sources.list(.d/) in order to install firmware-${nvidia}-gsp.

#Package: ${nvidia-kernel}-source
Package: nvidia-open-kernel-source
Architecture: amd64 arm64
Depends:
 debhelper-compat (= ${nvidia:debhelper-compat}),
 module-assistant,
 ${misc:Depends}
Recommends:
 firmware-${nvidia}-gsp (= ${nvidia:Version}) | firmware-nvidia-gsp-${nvidia:Version},
 ${nvidia-kernel}-support--v1,
Description: NVIDIA open kernel module source${nvidia:VariantDesc}
 This package provides the source for the NVIDIA binary kernel modules
 needed by ${nvidia}-driver in a form suitable
 for use by module-assistant.
 .
 The NVIDIA binary driver provides optimized hardware acceleration of
 OpenGL/GLX/EGL/GLES applications via a direct-rendering X Server
 for graphics cards using NVIDIA chip sets.
 .
 PLEASE read /usr/share/doc/${nvidia-kernel}-source/README.Debian.gz
 for building information. If you want the kernel module to be automatically
 installed via DKMS, install ${nvidia-kernel}-dkms instead.
 .
 ${nvidia:Models}
 .
 Building the kernel modules has been tested up to Linux ${nvidia:kmod:tested:Linux}.

=== debian/rules ===
#!/usr/bin/make -f

# For reproducible builds.
export DATE	 = env LC_ALL=POSIX date --utc --date="@$(SOURCE_DATE_EPOCH)"
export WHOAMI	 = echo buildd
export HOSTNAME	 = debian

# The generated object files are linked into kernel modules.
export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector

# Avoid warnings on C++ compilation
export DEB_CFLAGS_MAINT_STRIP	 = -Werror=implicit-function-declaration

include /usr/share/dpkg/pkg-info.mk

NVIDIA_RELEASE		 = $(DEB_VERSION_UPSTREAM)
NVIDIA_MAJOR		 = $(firstword $(subst ., ,$(NVIDIA_RELEASE)))
include debian/rules.defs
NVIDIA_TESLA		?=
LINUX_KMOD_VARIANT	?=
LINUX_KMOD_TESTED	?=
ARCH_LIST		?= amd64

version			 = $(NVIDIA_RELEASE)
version_major		 = $(NVIDIA_MAJOR)
variant			 = $(if $(NVIDIA_TESLA),tesla-$(NVIDIA_TESLA))
variant_description	 = $(if $(NVIDIA_TESLA), (Tesla $(NVIDIA_TESLA) version))
-variant		 = $(if $(variant),-$(variant))
nvidia			 = nvidia$(-variant)
current			 = $(if $(variant),$(variant),current)
module-current		 = $(current)$(LINUX_KMOD_VARIANT)
module			 = nvidia-$(module-current)
nvidia-kernel		 = $(nvidia)$(LINUX_KMOD_VARIANT)-kernel
debhelper_compat	:= $(shell sed -rn 's/.*debhelper-compat \(= ([0-9]+)\).*/\1/p' debian/control)

CONTROL_PREFIXES	 = nvidia-kernel
RENAME_nvidia-kernel	 = $(nvidia-kernel)
renamed_prefix		 = $(or $(RENAME_$1),$(subst nvidia,$(if $(filter %nvidia0 %nvidia1 %nvidia2,$1),$(nvidia-),$(nvidia)),$1))
CONTROL_PREFIXES_RENAMED = $(foreach p,$(CONTROL_PREFIXES),$(call renamed_prefix,$p))

# $1=file, $2=prefix
applyprefixrename	 = $(patsubst debian/$2%,debian/$(call renamed_prefix,$2)%,$1)
# $1=file, $2=prefixlist
applyprefixrenamelist	 = $(if $2,$(call applyprefixrenamelist,$(call applyprefixrename,$1,$(firstword $2)),$(wordlist 2,$(words $2),$2)),$1)

ALL_CONTROL	:= $(wildcard $(patsubst %,debian/%*,$(CONTROL_PREFIXES)))
LEGACY_CONTROL	:= $(wildcard $(patsubst %,debian/%*,$(CONTROL_PREFIXES_RENAMED)))
RENAME_CONTROL	 = $(filter-out $(LEGACY_CONTROL),$(ALL_CONTROL))
RENAMED_CONTROL	 = $(foreach f,$(RENAME_CONTROL),$(call applyprefixrenamelist,$f,$(CONTROL_PREFIXES)))

TEMPLATE_DIRS	 = debian
TEMPLATE_DIRS	+= debian/module/debian
TEMPLATE_DIRS	+= debian/tests
TEMPLATES	:= $(filter-out %.modules.in,$(wildcard $(addsuffix /*.in,$(TEMPLATE_DIRS))))

AUTOGEN		 = $(TEMPLATES:.in=)
AUTOGEN		+= $(RENAMED_CONTROL:.in=)
AUTOGEN		+= debian/module/debian/bug-control
AUTOGEN		+= debian/module/debian/control.modules.in
AUTOGEN		+= debian/bug-control
AUTOGEN		+= debian/substvars
AUTOGEN		+= $(AUTOKEEP)
AUTOKEEP	 =
AUTOKEEP	+= debian/tests/autopkgtest-pkg-dkms.conf
AUTOKEEP	+= debian/tests/control


.PHONY: binary binary-arch binary-indep build build-arch build-indep clean install
binary binary-arch binary-indep build build-arch build-indep clean install:
	dh $@

prepare: $(AUTOGEN)
	QUILT_PATCHES=debian/patches QUILT_SERIES=series-manual quilt --quiltrc /dev/null push -a || test $$? = 2
	cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null push -a || test $$? = 2

override_dh_auto_build: prepare
	dh_auto_build -- kernel-open/nvidia/nv-kernel.o_binary kernel-open/nvidia-modeset/nv-modeset-kernel.o_binary NV_VERBOSE=1
	find kernel-open -name '*.o_binary' -type l -exec sh -c 'ln -fv "$$(readlink -f "{}")" "{}"' \;

override_dh_auto_test: J_FLAG ?= $(patsubst parallel=%,-j%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test: TEST_KERNEL ?= $(shell ls -dvr1 /lib/modules/*/build 2>/dev/null | cut -d/ -f4 | head -n 1)
override_dh_auto_test:
	$(RM) -r test-module-build
	cp -a kernel-open test-module-build
	$(MAKE) $(J_FLAG) -C test-module-build NV_VERBOSE=1 KERNEL_UNAME=$(TEST_KERNEL)

# nothing to do
override_dh_auto_install:

override_dh_auto_clean:
	$(MAKE) nvidia.clean nvidia-modeset.clean
	find kernel-open -name '*.o_binary' | xargs -r $(RM) -v
	$(RM) -r test-module-build

execute_after_dh_clean:
	cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null pop -a || test $$? = 2
	$(RM) -r kernel-open/.pc/
	test ! -s .pc/applied-patches || quilt --quiltrc /dev/null pop -a || test $$? = 2
	$(RM) -r .pc/
	$(RM) $(filter-out $(AUTOKEEP),$(AUTOGEN))
	$(if $(AUTOKEEP),$(MAKE) -f debian/rules $(AUTOKEEP))

execute_after_dh_install: pack-module-source

override_dh_bugfiles:
	dh_bugfiles -A

override_dh_gencontrol:
	dh_gencontrol -- \
		-V'nvidia:Version=$(version)' \
		-V'nvidia:Version:major=$(version_major)' \
		-V'nvidia=$(nvidia)' \
		-V'nvidia-kernel=$(nvidia-kernel)' \
		-V'nvidia:Variant=$(variant)' \
		-V'nvidia:VariantDesc=$(variant_description)' \
		-V'nvidia:debhelper-compat=$(debhelper_compat)' \
		-V'nvidia:kmod:tested:Linux=$(strip $(or $(LINUX_KMOD_TESTED_$(DEB_HOST_ARCH)),$(LINUX_KMOD_TESTED),???))' \
		-Vnvidia:Models="`cat debian/control.models`"

# used by dpkg-genchanges
debian/substvars:
	echo 'nvidia:VariantDesc=$(variant_description)' > $@
	echo 'nvidia:VariantDescShort=$(variant_description_short)' >> $@

module_source_pkg	 = debian/$(nvidia-kernel)-source
module_source_txz	 = $(module_source_pkg)/usr/src/$(nvidia-kernel).tar.xz

pack-module-source:
	find $(module_source_pkg) \( -name '*.binary' -o -name '*.in' -not -name '*.modules.in' \) -print -delete
	tar c \
		-C $(module_source_pkg)/usr/src \
		--numeric-owner --owner=0 --group=0 \
		--mode=a=rX,u+w \
		--sort=name \
		--mtime='@$(SOURCE_DATE_EPOCH)' \
		--clamp-mtime \
		--remove-files \
		modules | xz -T1 -9 > $(module_source_txz)
	tar tfv $(module_source_txz)

############################################################################

.PHONY: autogen
autogen: $(AUTOGEN)

# Generating control files
%:: %.in debian/rules debian/rules.defs
	perl -p \
	-e 's{#VERSION#}{$(version)}g;' \
	-e 's{#MAJOR#}{$(version_major)}g;' \
	-e 's{#NVIDIA#}{$(nvidia)}g;' \
	-e 's{#VARIANT#}{$(-variant)}g;' \
	-e 's{#NVIDIA-KERNEL#}{$(nvidia-kernel)}g;' \
	-e 's{#MODULE#}{$(module)}g;' \
	-e 's{#MODULE_CURRENT#}{$(module-current)}g;' \
	-e 's{#ARCH_LIST#}{$(ARCH_LIST)}g;' \
	-e 's{#AUTOPKGTEST_ARCH_LIST#}{$(ARCH_LIST)}g;' \
	< $< > $@
	chmod --reference=$< $@

debian/module/debian/control.modules.in: debian/control debian/module/debian/control.modules.in.binary
	sed -n '/^#/d; 0,/^$$/p' $< > $@
	cat $(filter-out $<,$^) >> $@

debian/module/debian/bug-control: debian/bug-control
	cp $< $@
	echo "" >> $@
	echo "Submit-As: $(nvidia-kernel)-source" >> $@


define rename-template
$2%: $1%
	cp -a $$< $$@
endef
$(foreach p,$(CONTROL_PREFIXES),$(eval $(call rename-template,$p,$(call renamed_prefix,$p))))

include debian/bug-control.mk

## nvidia-open-gpu-kernel-modules 535.261.03

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (535.261.03-1) bookworm; urgency=medium

  * New upstream LTS and Tesla branch release 535.261.03 (2025-07-17).
    * Fixed CVE-2025-23279, CVE-2025-23286.  (Closes: #1109915)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5670
  * Sync with src:nvidia-graphics-drivers.
  * Upload to bookworm.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 21 Dec 2025 00:05:31 +0100

nvidia-open-gpu-kernel-modules (535.247.01-2) UNRELEASED; urgency=medium

  * Backport page_pgmap and hmm_make_device_exclusive_range changes from
    570.153.02 to fix open kernel module build for Linux 6.15.
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 06 Jun 2025 15:11:06 +0200

nvidia-open-gpu-kernel-modules (535.179-1) UNRELEASED; urgency=medium

  * New upstream long term support branch release 535.179 (2024-05-09).
  * New upstream long term support branch release 535.171.04 (2024-03-21).
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 18 Jun 2024 09:58:53 +0200

## nvidia-open-gpu-kernel-modules 545.23.06

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (545.23.06-4) experimental; urgency=medium

  * Backport NV_FOLIO_TEST_SWAPCACHE_PRESENT changes from 565.57.01 and
    NV_MODULE_IMPORT_NS_TAKES_CONSTANT changes from 570.86.15 to fix open
    kernel module build for Linux 6.13.
  * Work around a pahole deadlock while generating btf debug info for the open
    kernel module.  (Closes: #1098812)
  * Fix warnings during open module build.
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Mar 2025 20:00:14 +0100

nvidia-open-gpu-kernel-modules (545.23.06-3) experimental; urgency=medium

  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 20 Feb 2025 21:21:38 +0100

nvidia-open-gpu-kernel-modules (545.23.06-2) experimental; urgency=medium

  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 10 Nov 2024 21:51:16 +0100

nvidia-open-gpu-kernel-modules (545.23.06-1) experimental; urgency=medium

  * New upstream beta 545.23.06 (2023-10-17).
  * Sync with src:nvidia-graphics-drivers.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 29 Mar 2024 09:59:11 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,6 @@
 
 # The generated object files are linked into kernel modules.
 export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector
-
-# Avoid warnings on C++ compilation
-export DEB_CFLAGS_MAINT_STRIP	 = -Werror=implicit-function-declaration
 
 include /usr/share/dpkg/pkg-info.mk
 
@@ -70,7 +67,6 @@
 	dh $@
 
 prepare: $(AUTOGEN)
-	QUILT_PATCHES=debian/patches QUILT_SERIES=series-manual quilt --quiltrc /dev/null push -a || test $$? = 2
 	cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null push -a || test $$? = 2
 
 override_dh_auto_build: prepare
@@ -93,10 +89,8 @@
 	$(RM) -r test-module-build
 
 execute_after_dh_clean:
-	cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null pop -a || test $$? = 2
+	if [ -f debian/patches/module/series ]; then cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null pop -a || test $$? = 2 ; fi
 	$(RM) -r kernel-open/.pc/
-	test ! -s .pc/applied-patches || quilt --quiltrc /dev/null pop -a || test $$? = 2
-	$(RM) -r .pc/
 	$(RM) $(filter-out $(AUTOKEEP),$(AUTOGEN))
 	$(if $(AUTOKEEP),$(MAKE) -f debian/rules $(AUTOKEEP))

## nvidia-open-gpu-kernel-modules 550.144.03

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (550.144.03-1) unstable; urgency=medium

  * New upstream production and Tesla branch release 550.144.03 (2025-01-16).
    * Fixed CVE-2024-0150, CVE-2024-0147, CVE-2024-53869, CVE-2024-0131,
      CVE-2024-0149.  (Closes: #1093916)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5614
  * New upstream production branch release 550.142 (2024-12-17).
  * Sync with src:nvidia-graphics-drivers.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 22 May 2025 08:05:14 +0200

nvidia-open-gpu-kernel-modules (550.135-1) experimental; urgency=medium

  * New upstream production branch release 550.135 (2024-11-19).
  * New upstream Tesla branch release 550.127.08 (2024-11-19).
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 19 May 2025 21:31:11 +0200

nvidia-open-gpu-kernel-modules (550.127.05-1) experimental; urgency=medium

  * New upstream production and Tesla branch release 550.127.05 (2024-10-22).
    * Fixed CVE-2024-0126.  (Closes: #1085976)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5586
  * New upstream production branch release 550.120 (2024-09-19).
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Sun, 18 May 2025 19:06:54 +0200

nvidia-open-gpu-kernel-modules (550.107.02-1) experimental; urgency=medium

  * New upstream production branch release 550.107.02 (2024-07-29).
  * New upstream production branch release 550.100 (2024-07-09).
  * New upstream Tesla branch release 550.90.12 (2024-09-10).
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Sat, 17 May 2025 01:59:44 +0200

nvidia-open-gpu-kernel-modules (550.90.07-1) experimental; urgency=medium

  * New upstream production and Tesla branch release 550.90.07 (2024-06-04).
    * Fixed CVE-2024-0090, CVE-2024-0091, CVE-2024-0092.  (Closes: #1072800)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5551
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 12 May 2025 20:07:19 +0200

nvidia-open-gpu-kernel-modules (550.78-1) experimental; urgency=medium

  * New upstream production branch release 550.78 (2024-04-25).
  * New upstream production branch release 550.76 (2024-04-16).
  * New upstream production branch release 550.67 (2024-03-19).
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 09 May 2025 18:52:17 +0200

nvidia-open-gpu-kernel-modules (550.54.15-1) experimental; urgency=medium

  * New upstream Tesla branch release 550.54.15 (2024-03-18).
  * New upstream production and Tesla branch release 550.54.14 (2024-02-23).
    * Fixed CVE-2024-0074, CVE-2024-0078, CVE-2022-42265.  (Closes: #1064991)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5520
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 29 Apr 2025 13:25:37 +0200

nvidia-open-gpu-kernel-modules (550.40.07-1) experimental; urgency=medium

  * New upstream beta 550.40.07 (2024-01-24).
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 23 Apr 2025 15:13:48 +0200

nvidia-open-gpu-kernel-modules (545.29.06-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 16 May 2025 00:21:10 +0200

nvidia-open-gpu-kernel-modules (545.29.06-1) experimental; urgency=medium

  * New upstream new feature branch release 545.29.06 (2023-11-22).
  * New upstream new feature branch release 545.29.02 (2023-10-31).
    * Fixed CVE-2023-31022.  (Closes: #1055144)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5491
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 16 Apr 2025 10:17:58 +0200

nvidia-open-gpu-kernel-modules (545.23.06-6) experimental; urgency=medium

  * Do not add -mfunction-return=thunk-extern flag, breaks backwards
    compatibility with kernels built without this flag.
  * Apply both patch sets manually.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 14 Apr 2025 18:42:42 +0200

nvidia-open-gpu-kernel-modules (545.23.06-5) experimental; urgency=medium

  * Backport NV_CRYPTO_AKCIPHER_VERIFY_PRESENT changes from 550.144.03 to fix
    open kernel module build for Linux 6.13.
  * Let pahole ignore language c++11 for BTF generation.  (Closes: #1098812)
  * Fix warnings during open module build.
  * Build with more kernel hardening flags.
  * Sync with src:nvidia-graphics-drivers.
  * Bump Standards-Version to 4.7.2. No changes needed.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 01 Apr 2025 21:00:29 +0200

## nvidia-open-gpu-kernel-modules 550.163.01

=== Makefile ===
###########################################################################
# This is the top level makefile for the NVIDIA Linux kernel module source
# package.
#
# To build: run `make modules`
# To install the build kernel modules: run (as root) `make modules_install`
###########################################################################

###########################################################################
# variables
###########################################################################

nv_kernel_o                = src/nvidia/$(OUTPUTDIR)/nv-kernel.o
nv_kernel_o_binary         = kernel-open/nvidia/nv-kernel.o_binary

nv_modeset_kernel_o        = src/nvidia-modeset/$(OUTPUTDIR)/nv-modeset-kernel.o
nv_modeset_kernel_o_binary = kernel-open/nvidia-modeset/nv-modeset-kernel.o_binary

###########################################################################
# rules
###########################################################################

include utils.mk

.PHONY: all
all: modules

###########################################################################
# nv-kernel.o is the OS agnostic portion of nvidia.ko
###########################################################################

.PHONY: $(nv_kernel_o)
$(nv_kernel_o):
	$(MAKE) -C src/nvidia

$(nv_kernel_o_binary): $(nv_kernel_o)
	cd $(dir $@) && ln -sf ../../$^ $(notdir $@)


###########################################################################
# nv-modeset-kernel.o is the OS agnostic portion of nvidia-modeset.ko
###########################################################################

.PHONY: $(nv_modeset_kernel_o)
$(nv_modeset_kernel_o):
	$(MAKE) -C src/nvidia-modeset

$(nv_modeset_kernel_o_binary): $(nv_modeset_kernel_o)
	cd $(dir $@) && ln -sf ../../$^ $(notdir $@)


###########################################################################
# After the OS agnostic portions are built, descend into kernel-open/ and build
# the kernel modules with kbuild.
###########################################################################

.PHONY: modules
modules: $(nv_kernel_o_binary) $(nv_modeset_kernel_o_binary)
	$(MAKE) -C kernel-open modules

###########################################################################
# Install the built kernel modules using kbuild.
###########################################################################

.PHONY: modules_install
modules_install:
	$(MAKE) -C kernel-open modules_install

###########################################################################
# clean
###########################################################################

.PHONY: clean
clean: nvidia.clean nvidia-modeset.clean kernel-open.clean

.PHONY: nvidia.clean
nvidia.clean:
	$(MAKE) -C src/nvidia clean

.PHONY: nvidia-modeset.clean
nvidia-modeset.clean:
	$(MAKE) -C src/nvidia-modeset clean

.PHONY: kernel-open.clean
kernel-open.clean:
	$(MAKE) -C kernel-open clean

=== src/nvidia-modeset/Makefile ===
###########################################################################
# Makefile for nv-modeset-kernel.o
###########################################################################

NV_MODULE_LOGGING_NAME ?= nvidia-modeset

VERSION_MK_DIR = ../../
include ../../utils.mk

include srcs.mk

##############################################################################
# Helper functions to determine the compiler type
##############################################################################
GET_COMPILER_TYPE = \
  $(shell $(VERSION_MK_DIR)/nv-compiler.sh type $(1))
##############################################################################

# The source files for nv-modeset-kernel.o are all SRCS and SRCS_CXX defined in
# srcs.mk, and the NVIDIA ID string
ALL_SRCS = $(SRCS) $(SRCS_CXX)
ALL_SRCS += $(NVIDSTRING)

SRC_COMMON = ../common

CONDITIONAL_CFLAGS :=

CFLAGS += -include $(SRC_COMMON)/sdk/nvidia/inc/cpuopsys.h

CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc
CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc/hw
CFLAGS += -I $(SRC_COMMON)/shared/inc
CFLAGS += -I $(SRC_COMMON)/inc
CFLAGS += -I $(SRC_COMMON)/softfloat/nvidia
CFLAGS += -I $(SRC_COMMON)/softfloat/source/include
CFLAGS += -I $(SRC_COMMON)/softfloat/source/8086-SSE
CFLAGS += -I $(SRC_COMMON)/unix/common/utils/interface
CFLAGS += -I $(SRC_COMMON)/unix/common/inc
CFLAGS += -I $(SRC_COMMON)/modeset
CFLAGS += -I os-interface/include
CFLAGS += -I kapi/interface
CFLAGS += -I ../nvidia/arch/nvalloc/unix/include
CFLAGS += -I interface
CFLAGS += -I include
CFLAGS += -I kapi/include
CFLAGS += -I generated
CFLAGS += -I $(SRC_COMMON)/displayport/inc
CFLAGS += -I $(SRC_COMMON)/displayport/inc/dptestutil
CFLAGS += -I $(SRC_COMMON)/inc/displayport

CFLAGS += -DNDEBUG
CFLAGS += -D_LANGUAGE_C
CFLAGS += -D__NO_CTYPE

CFLAGS += -DNV_CPU_INTRINSICS_KERNEL
CFLAGS += -DNVHDMIPKT_RM_CALLS_INTERNAL=0

# XXX it would be nice to only define these for appropriate files...
CFLAGS += -DSOFTFLOAT_ROUND_ODD
CFLAGS += -DSOFTFLOAT_FAST_DIV32TO16
CFLAGS += -DSOFTFLOAT_FAST_DIV64TO32

# Tell nvtiming to use nvkms import functions
CFLAGS += -DNVT_USE_NVKMS

CFLAGS += -Wformat
CFLAGS += -Wreturn-type
CFLAGS += -Wswitch
CFLAGS += -Wunused-local-typedefs
CFLAGS += -Wchar-subscripts
CFLAGS += -Wparentheses
CFLAGS += -Wpointer-arith
CFLAGS += -Wcast-qual
CFLAGS += -Wall
CFLAGS += -Wextra
CFLAGS += -Wno-sign-compare
CFLAGS += -Wno-unused-parameter
CFLAGS += -Wno-missing-field-initializers
CFLAGS += -Wno-format-zero-length
CFLAGS += -Wmissing-declarations
CFLAGS += -Wno-cast-qual

CFLAGS += -O2

ifeq ($(TARGET_ARCH),x86_64)
  CFLAGS += -msoft-float
  CFLAGS += -mno-red-zone
  CFLAGS += -mcmodel=kernel
  CFLAGS += -mno-mmx
  CFLAGS += -mno-sse
  CFLAGS += -mno-sse2
  CFLAGS += -mno-3dnow
endif

ifeq ($(TARGET_ARCH),aarch64)
  CFLAGS += -mgeneral-regs-only
  CFLAGS += -march=armv8-a
  CFLAGS += -ffixed-x18
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mno-outline-atomics)
endif

ifeq ($(TARGET_ARCH),riscv64)
  CFLAGS += -march=rv64imac_zicsr_zifencei
  CFLAGS += -mabi=lp64
  CFLAGS += -mcmodel=medany
  CFLAGS += -mno-relax
endif

CFLAGS += -fno-pic
CFLAGS += -fno-common
CFLAGS += -fomit-frame-pointer
CFLAGS += -fno-strict-aliasing
CFLAGS += -ffunction-sections
CFLAGS += -fdata-sections
CFLAGS += -ffreestanding
CFLAGS += -fno-stack-protector

CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -Wformat-overflow=2)
CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -Wformat-truncation=1)

ifeq ($(TARGET_ARCH),x86_64)
  COMPILER_TYPE := $(call GET_COMPILER_TYPE, $(CC))
  ENDBR_SUPPORTED := $(call AS_HAS_INSTR, endbr64)

  FCF_SUPPORTED =

  #
  # GCC flags -fcf-protection=branch and -mindirect-branch=extern-thunk can
  # be used together after GCC version 9.4.0. See 
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93654 for details.
  # Check if GCC version is appropriate.
  #
  ifeq ($(COMPILER_TYPE),gcc)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 90400)
  endif

  #
  # Clang version 14.0.0 is required for -fcf-protection=branch to work
  # correctly. See commit
  # https://github.com/llvm/llvm-project/commit/dfcf69770bc522b9e411c66454934a37c1f35332
  #
  ifeq ($(COMPILER_TYPE),clang)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 140000)
  endif

  ifeq ($(FCF_SUPPORTED)-$(ENDBR_SUPPORTED),1-1)
    CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fcf-protection=branch)
  endif
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fno-jump-tables)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch=thunk-extern)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch-register)
endif

CFLAGS += $(CONDITIONAL_CFLAGS)

CC_ONLY_CFLAGS += -Wimplicit
CC_ONLY_CFLAGS += -Wstrict-prototypes
CC_ONLY_CFLAGS += -Wmissing-prototypes
CC_ONLY_CFLAGS += -std=gnu11

CXX_ONLY_CFLAGS += -std=gnu++11
CXX_ONLY_CFLAGS += -fno-operator-names
CXX_ONLY_CFLAGS += -fno-rtti
CXX_ONLY_CFLAGS += -fno-exceptions
CXX_ONLY_CFLAGS += -fcheck-new

SHADER_OBJS =

  CFLAGS += -DNVKMS_INCLUDE_HEADSURFACE=1

  CFLAGS += -I $(SRC_COMMON)/unix/nvidia-3d/interface
  CFLAGS += -I $(SRC_COMMON)/unix/nvidia-push/interface
  CFLAGS += -I $(SRC_COMMON)/unix/nvidia-3d/include
  CFLAGS += -I $(SRC_COMMON)/unix/nvidia-push/include
  CFLAGS += -I $(SRC_COMMON)/unix/xzminidec/interface
  CFLAGS += -I $(SRC_COMMON)/unix/nvidia-headsurface
  CFLAGS += -I src/shaders

  CFLAGS += -DNV_PUSH_IN_KERNEL
  CFLAGS += -DNV_XZ_CUSTOM_MEM_HOOKS
  CFLAGS += -DNV_XZ_USE_NVTYPES
  CFLAGS += -DXZ_DEC_SINGLE

  # Compress the shaders and embed in ELF object files.
  define COMPRESS_SHADERS
    $$(OUTPUTDIR)/$(1)_shaders.xz: src/shaders/g_$(1)_shaders
	@$(MKDIR) $$(OUTPUTDIR)
	$$(call quiet_cmd,XZ) -ce -C none < $$^ > $$@

    $$(eval $$(call READ_ONLY_OBJECT_FROM_FILE_RULE,$$(OUTPUTDIR)/$(1)_shaders.xz))

    SHADER_OBJS += $$(OUTPUTDIR)/$(1)_shaders.xz.o
  endef

  $(eval $(call COMPRESS_SHADERS,maxwell))
  $(eval $(call COMPRESS_SHADERS,pascal))
  $(eval $(call COMPRESS_SHADERS,volta))
  $(eval $(call COMPRESS_SHADERS,turing))
  $(eval $(call COMPRESS_SHADERS,ampere))
    $(eval $(call COMPRESS_SHADERS,hopper))

OBJS = $(call BUILD_OBJECT_LIST,$(ALL_SRCS))
OBJS += $(SHADER_OBJS)

# Define how to generate the NVIDIA ID string
$(eval $(call GENERATE_NVIDSTRING, \
  NV_KMS_ID, \
  UNIX Open Kernel Mode Setting Driver, $(OBJS)))

# Define how to build each object file from the corresponding source file.
$(foreach src, $(ALL_SRCS), $(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))

NV_MODESET_KERNEL_O = $(OUTPUTDIR)/nv-modeset-kernel.o

.PHONY: all
all: $(NV_MODESET_KERNEL_O)

$(NV_MODESET_KERNEL_O): $(OBJS)
	$(call quiet_cmd,LD) -r -o $(NV_MODESET_KERNEL_O) $(OBJS)

.PHONY: clean
clean:
	$(RM) -rf $(OUTPUTDIR)

=== src/nvidia/Makefile ===
###########################################################################
# Makefile for nv-kernel.o
###########################################################################

NV_MODULE_LOGGING_NAME ?= nvidia

VERSION_MK_DIR = ../../

include ../../utils.mk

include srcs.mk

##############################################################################
# Helper functions to determine the compiler type
##############################################################################
GET_COMPILER_TYPE = \
  $(shell $(VERSION_MK_DIR)/nv-compiler.sh type $(1))
##############################################################################

# The source files for nv-kernel.o are all SRCS and SRCS_CXX defined in srcs.mk,
# and the NVIDIA ID string
ALL_SRCS = $(SRCS) $(SRCS_CXX)
ALL_SRCS += $(NVIDSTRING)

SRC_COMMON = ../common
CONDITIONAL_CFLAGS :=

CFLAGS += -include $(SRC_COMMON)/sdk/nvidia/inc/cpuopsys.h

CFLAGS += -I kernel/inc
CFLAGS += -I interface
CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc
CFLAGS += -I $(SRC_COMMON)/sdk/nvidia/inc/hw
CFLAGS += -I arch/nvalloc/common/inc
CFLAGS += -I arch/nvalloc/common/inc/gsp
CFLAGS += -I arch/nvalloc/common/inc/deprecated
CFLAGS += -I arch/nvalloc/unix/include
CFLAGS += -I inc
CFLAGS += -I inc/os
CFLAGS += -I $(SRC_COMMON)/shared/inc
CFLAGS += -I $(SRC_COMMON)/shared/msgq/inc
CFLAGS += -I $(SRC_COMMON)/inc

CFLAGS += -I $(SRC_COMMON)/uproc/os/libos-v2.0.0/include
CFLAGS += -I $(SRC_COMMON)/uproc/os/common/include
CFLAGS += -I $(SRC_COMMON)/inc/swref
CFLAGS += -I $(SRC_COMMON)/inc/swref/published

CFLAGS += -I generated
CFLAGS += -I $(SRC_COMMON)/nvswitch/kernel/inc
CFLAGS += -I $(SRC_COMMON)/nvswitch/interface
CFLAGS += -I $(SRC_COMMON)/nvswitch/common/inc/
CFLAGS += -I $(SRC_COMMON)/inc/displayport
CFLAGS += -I $(SRC_COMMON)/nvlink/interface/
CFLAGS += -I $(SRC_COMMON)/nvlink/inband/interface
CFLAGS += -I src/mm/uvm/interface
CFLAGS += -I inc/libraries
CFLAGS += -I src/libraries
CFLAGS += -I inc/kernel

# Libspdm source requires additional include paths and build flags.
include src/libraries/libspdm/nvidia/openspdm.mk
$(call BUILD_OBJECT_LIST,$(LIBSPDM_SOURCES)): CFLAGS += $(addprefix -I ,$(LIBSPDM_INCLUDES))
$(call BUILD_OBJECT_LIST,$(LIBSPDM_SOURCES)): CFLAGS += $(addprefix -D,$(LIBSPDM_DEFINES))

#if NV_USE_MBEDTLS
CFLAGS += -I $(SRC_COMMON)/mbedtls/include
CFLAGS += -I $(SRC_COMMON)/mbedtls/nvidia
CFLAGS += -DMBEDTLS_USER_CONFIG_FILE=\"nvrm_mbedtls_config.h\"
#endif

CFLAGS += -Werror-implicit-function-declaration
CFLAGS += -Wwrite-strings
CFLAGS += -Wundef
CFLAGS += -fno-common
CFLAGS += -ffreestanding
CFLAGS += -fno-stack-protector

ifeq ($(TARGET_ARCH),x86_64)
  CFLAGS += -msoft-float
  CFLAGS += -mno-red-zone
  CFLAGS += -mcmodel=kernel
  CFLAGS += -mno-mmx
  CFLAGS += -mno-sse
  CFLAGS += -mno-sse2
  CFLAGS += -mno-3dnow
endif

ifeq ($(TARGET_ARCH),aarch64)
  CFLAGS += -mgeneral-regs-only
  CFLAGS += -march=armv8-a
  CFLAGS += -mstrict-align
  CFLAGS += -ffixed-x18
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mno-outline-atomics)
endif

ifeq ($(TARGET_ARCH),riscv64)
  CFLAGS += -march=rv64imac_zicsr_zifencei
  CFLAGS += -mabi=lp64
  CFLAGS += -mcmodel=medany
  CFLAGS += -mno-relax
endif

CFLAGS += -fno-pic

CFLAGS += -D_LANGUAGE_C
CFLAGS += -D__NO_CTYPE
CFLAGS += -DNVRM
CFLAGS += -DLOCK_VAL_ENABLED=0
CFLAGS += -DPORT_ATOMIC_64_BIT_SUPPORTED=1
CFLAGS += -DPORT_IS_KERNEL_BUILD=1
CFLAGS += -DPORT_IS_CHECKED_BUILD=1
CFLAGS += -DPORT_MODULE_atomic=1
CFLAGS += -DPORT_MODULE_core=1
CFLAGS += -DPORT_MODULE_cpu=1
CFLAGS += -DPORT_MODULE_crypto=1
CFLAGS += -DPORT_MODULE_debug=1
CFLAGS += -DPORT_MODULE_memory=1
CFLAGS += -DPORT_MODULE_safe=1
CFLAGS += -DPORT_MODULE_string=1
CFLAGS += -DPORT_MODULE_sync=1
CFLAGS += -DPORT_MODULE_thread=1
CFLAGS += -DPORT_MODULE_util=1
CFLAGS += -DPORT_MODULE_example=0
CFLAGS += -DPORT_MODULE_mmio=0
CFLAGS += -DPORT_MODULE_time=0
CFLAGS += -DRS_STANDALONE=0
CFLAGS += -DRS_STANDALONE_TEST=0
CFLAGS += -DRS_COMPATABILITY_MODE=1
CFLAGS += -DRS_PROVIDES_API_STATE=0
CFLAGS += -DNV_CONTAINERS_NO_TEMPLATES

CFLAGS += -DINCLUDE_NVLINK_LIB
CFLAGS += -DINCLUDE_NVSWITCH_LIB

CFLAGS += -DNV_PRINTF_STRINGS_ALLOWED=1
CFLAGS += -DNV_ASSERT_FAILED_USES_STRINGS=1
CFLAGS += -DPORT_ASSERT_FAILED_USES_STRINGS=1

ifeq ($(DEBUG),1)
  CFLAGS += -gsplit-dwarf
endif

# Define how to perform dead code elimination: place each symbol in its own
# section at compile time, and garbage collect unreachable sections at link
# time.  exports_link_command.txt tells the linker which symbols need to be
# exported from nv-kernel.o so the linker can determine which symbols are
# unreachable.
CFLAGS += -ffunction-sections
CFLAGS += -fdata-sections
NV_KERNEL_O_LDFLAGS += --gc-sections
EXPORTS_LINK_COMMAND = exports_link_command.txt

ifeq ($(TARGET_ARCH),x86_64)
  COMPILER_TYPE := $(call GET_COMPILER_TYPE, $(CC))
  ENDBR_SUPPORTED := $(call AS_HAS_INSTR, endbr64)

  FCF_SUPPORTED =

  #
  # GCC flags -fcf-protection=branch and -mindirect-branch=extern-thunk can
  # be used together after GCC version 9.4.0. See 
  # https://gcc.gnu.org/bugzilla/show_bug.cgi?id=93654 for details.
  # Check if GCC version is appropriate.
  #
  ifeq ($(COMPILER_TYPE),gcc)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 90400)
  endif

  #
  # Clang version 14.0.0 is required for -fcf-protection=branch to work
  # correctly. See commit
  # https://github.com/llvm/llvm-project/commit/dfcf69770bc522b9e411c66454934a37c1f35332
  #
  ifeq ($(COMPILER_TYPE),clang)
    FCF_SUPPORTED := \
      $(shell $(VERSION_MK_DIR)/nv-compiler.sh version_is_at_least $(CC) 140000)
  endif

  ifeq ($(FCF_SUPPORTED)-$(ENDBR_SUPPORTED),1-1)
    CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fcf-protection=branch)
  endif
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -fno-jump-tables)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch-register)
  CONDITIONAL_CFLAGS += $(call TEST_CC_ARG, -mindirect-branch=thunk-extern)
endif

CFLAGS += $(CONDITIONAL_CFLAGS)

CC_ONLY_CFLAGS += --std=gnu11
CXX_ONLY_CFLAGS += --std=gnu++11

OBJS = $(call BUILD_OBJECT_LIST,$(ALL_SRCS))

# Define how to generate the NVIDIA ID string
$(eval $(call GENERATE_NVIDSTRING, \
  NVRM_ID, \
  UNIX Open Kernel Module, $(OBJS)))

# Define how to build each object file from the corresponding source file.
$(foreach src, $(ALL_SRCS), $(eval $(call DEFINE_OBJECT_RULE,TARGET,$(src))))

NV_KERNEL_O = $(OUTPUTDIR)/nv-kernel.o

.PHONY: all
all: $(NV_KERNEL_O)

LINKER_SCRIPT = nv-kernel.ld

$(NV_KERNEL_O): $(OBJS) $(EXPORTS_LINK_COMMAND) $(LINKER_SCRIPT)
	$(call quiet_cmd,LD) \
	  $(NV_KERNEL_O_LDFLAGS) \
	  -T $(LINKER_SCRIPT) \
	  -r -o $(NV_KERNEL_O) $(OBJS) @$(EXPORTS_LINK_COMMAND)
	$(call quiet_cmd,OBJCOPY) \
	  --localize-symbol=memset \
	  --localize-symbol=memcpy \
	  $@

.PHONY: clean
clean:
	$(RM) -rf $(OUTPUTDIR)

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (550.163.01-3) unstable; urgency=medium

  * Backport NV_DMA_BUF_HAS_DYNAMIC_ATTACHMENT changes from 535.261.03 to fix
    open kernel module build for Linux 6.16.  (Closes: #1112186)
  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 28 Aug 2025 09:22:01 +0200

nvidia-open-gpu-kernel-modules (550.163.01-2) unstable; urgency=medium

  * Sync with src:nvidia-graphics-drivers.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 21 Jul 2025 23:45:24 +0200

nvidia-open-gpu-kernel-modules (550.163.01-1) unstable; urgency=medium

  * New upstream production and Tesla branch release 550.163.01 (2025-04-17).
    * Fixed CVE-2025-23244.  (Closes: #1104076)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5630
  * Sync with src:nvidia-graphics-drivers.
  * Upload to unstable.

 -- Andreas Beckmann <anbe@debian.org>  Wed, 11 Jun 2025 22:32:55 +0200

nvidia-open-gpu-kernel-modules (550.144.03-2) experimental; urgency=medium

  * Backport page_pgmap and hmm_make_device_exclusive_range changes from
    570.153.02 to fix open kernel module build for Linux 6.15.
  * Sync with src:nvidia-graphics-drivers.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 10 Jun 2025 09:42:04 +0200

nvidia-open-gpu-kernel-modules (550.100-1) UNRELEASED; urgency=medium

  * New upstream production branch release 550.100 (2024-07-09).
  * New upstream Tesla branch release 550.90.12 (2024-09-10).

 -- Andreas Beckmann <anbe@debian.org>  Sat, 17 May 2025 01:02:55 +0200

=== debian/tests/control ===
Test-Command: env BUILD_EXCLUSIVE_CONFIG="!CONFIG_PREEMPT_RT !CONFIG_PREEMPT_RT_FULL" /usr/share/modass/module-assistant-autopkgtest nvidia-open-kernel
Features: test-name=m-a-autopkgtest
Architecture: amd64 arm64
Depends:
 nvidia-open-kernel-source,
 module-assistant-autopkgtest,
 linux-doc,
Restrictions:
 superficial,
 needs-root,
 breaks-testbed,
 allow-stderr,

## nvidia-open-gpu-kernel-modules 555.42.02

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (555.42.02-1) experimental; urgency=medium

  * New upstream beta 555.42.02 (2024-05-21).
  * Backport NV_DMA_BUF_HAS_DYNAMIC_ATTACHMENT changes from 535.261.03 to fix
    open kernel module build for Linux 6.16.
  * Backport page_pgmap and hmm_make_device_exclusive_range changes from
    570.153.02 to fix open kernel module build for Linux 6.15.
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.
  * Upload to experimental.

 -- Andreas Beckmann <anbe@debian.org>  Tue, 29 Jul 2025 12:38:01 +0200

## nvidia-open-gpu-kernel-modules 555.58.02

=== src/nvidia/Makefile ===
--- 
+++ 
@@ -216,6 +216,7 @@
 	$(call quiet_cmd,OBJCOPY) \
 	  --localize-symbol=memset \
 	  --localize-symbol=memcpy \
+	  --remove-section=.note.gnu.property \
 	  $@
 
 .PHONY: clean

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (555.58.02-2) experimental; urgency=medium

  * Sync with src:nvidia-graphics-drivers.  (Closes: #1120470)

 -- Andreas Beckmann <anbe@debian.org>  Sun, 16 Nov 2025 01:49:08 +0100

nvidia-open-gpu-kernel-modules (555.58.02-1) experimental; urgency=medium

  * New upstream new feature branch release 555.58.02 (2024-07-01).
  * New upstream new feature branch release 555.58 (2024-06-27).
  * New upstream beta 555.52.04 (2024-06-05).
    * Fixed CVE-2024-0090, CVE-2024-0091, CVE-2024-0092.  (Closes: #1072800)
      https://nvidia.custhelp.com/app/answers/detail/a_id/5551
  * Sync with src:nvidia-graphics-drivers.
  * Refresh patches.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 31 Jul 2025 11:34:47 +0200

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,9 @@
 
 # The generated object files are linked into kernel modules.
 export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector
+
+# Avoid warnings on C++ compilation
+export DEB_CFLAGS_MAINT_STRIP	 = -Werror=implicit-function-declaration
 
 include /usr/share/dpkg/pkg-info.mk
 
@@ -67,6 +70,7 @@
 	dh $@
 
 prepare: $(AUTOGEN)
+	QUILT_PATCHES=debian/patches QUILT_SERIES=series-manual quilt --quiltrc /dev/null push -a || test $$? = 2
 	cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null push -a || test $$? = 2
 
 override_dh_auto_build: prepare
@@ -89,8 +93,10 @@
 	$(RM) -r test-module-build
 
 execute_after_dh_clean:
-	if [ -f debian/patches/module/series ]; then cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null pop -a || test $$? = 2 ; fi
+	cd kernel-open && QUILT_PATCHES=../debian/patches/module quilt --quiltrc /dev/null pop -a || test $$? = 2
 	$(RM) -r kernel-open/.pc/
+	test ! -s .pc/applied-patches || quilt --quiltrc /dev/null pop -a || test $$? = 2
+	$(RM) -r .pc/
 	$(RM) $(filter-out $(AUTOKEEP),$(AUTOGEN))
 	$(if $(AUTOKEEP),$(MAKE) -f debian/rules $(AUTOKEEP))
 
@@ -129,7 +135,7 @@
 		--mtime='@$(SOURCE_DATE_EPOCH)' \
 		--clamp-mtime \
 		--remove-files \
-		modules | xz -T1 -9 > $(module_source_txz)
+		modules | xz -T+1 -9 > $(module_source_txz)
 	tar tfv $(module_source_txz)
 
 ############################################################################

## nvidia-open-gpu-kernel-modules 580.95.05

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (580.95.05-0tux1) testing-nvidia; urgency=medium

  * New upstream release.

 -- Torsten Wohlfarth <two@tuxedocomputers.com>  Wed, 15 Oct 2025 12:24:30 +0200

nvidia-open-gpu-kernel-modules (575.64.05-0~tux1) testing-nvidia; urgency=medium

  * New upstream release.

 -- Torsten Wohlfarth <two@tuxedocomputers.com>  Fri, 05 Sep 2025 09:57:47 +0200

nvidia-open-gpu-kernel-modules (575.64-0tux1) testing-nvidia; urgency=medium

  * New upstream release.

 -- Torsten Wohlfarth <two@tuxedocomputers.com>  Wed, 18 Jun 2025 13:49:49 +0200

=== debian/control ===
--- 
+++ 
@@ -25,7 +25,7 @@
 Depends:
  ${nvidia}-alternative-${nvidia:Version} | nvidia-alternative-${nvidia:Version},
  nvidia-kernel-common (>= 20151021),
- nvidia-modprobe (>= ${nvidia:Version:major}),
+ nvidia-modprobe (>= 570),
  ${misc:Depends}
 Provides:
  nvidia-kernel-support-any,

=== debian/rules ===
--- 
+++ 
@@ -4,6 +4,7 @@
 export DATE	 = env LC_ALL=POSIX date --utc --date="@$(SOURCE_DATE_EPOCH)"
 export WHOAMI	 = echo buildd
 export HOSTNAME	 = debian
+export LDFLAGS   = 
 
 # The generated object files are linked into kernel modules.
 export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector

## nvidia-open-gpu-kernel-modules 580.105.08

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (580.105.08-0tux1) testing; urgency=medium

  * New upstream release.
    https://www.nvidia.com/en-us/drivers/details/257493/

 -- Torsten Wohlfarth <two@tuxedocomputers.com>  Wed, 12 Nov 2025 22:03:53 +0100

## nvidia-open-gpu-kernel-modules 580.119.02

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (580.119.02-0~tux1) testing; urgency=medium

  * New upstream release.
    https://www.nvidia.com/en-us/drivers/details/259042/

 -- Torsten Wohlfarth <two@tuxedocomputers.com>  Tue, 16 Dec 2025 14:20:23 +0100

## nvidia-open-gpu-kernel-modules 580.126.18

=== debian/changelog ===
nvidia-open-gpu-kernel-modules (580.126.18-1~tux1) testing; urgency=medium

  * New upstream release.
    https://www.nvidia.com/download/driverResults.aspx/264090/en-us/

 -- Torsten Wohlfarth <tux@tuxedocomputers.com>  Fri, 20 Feb 2026 09:38:10 +0100

nvidia-open-gpu-kernel-modules (580.126.09-2~tux1) testing; urgency=medium

  * force modeset and fbdev to 1 for nvidia-drm

 -- Torsten Wohlfarth <tux@tuxedocomputers.com>  Mon, 09 Feb 2026 11:12:46 +0100

nvidia-open-gpu-kernel-modules (580.126.09-1~tux1) testing; urgency=medium

  * fix debian/nvidia-load.conf.in

 -- Torsten Wohlfarth <tux@tuxedocomputers.com>  Thu, 05 Feb 2026 17:08:24 +0100

nvidia-open-gpu-kernel-modules (580.126.09-0~tux1) testing; urgency=medium

  * New upstream release.
    CHanges: https://www.nvidia.com/en-us/drivers/details/261243/

 -- Torsten Wohlfarth <tux@tuxedocomputers.com>  Thu, 15 Jan 2026 10:44:32 +0100
